const path = require('path')
const fs = require('fs')
const toml = require('toml')
const configfilePath = path.resolve(__dirname, '../fed/config.toml')
const configuration = toml.parse(fs.readFileSync(configfilePath, 'utf-8'))
const HtmlWebpackPlugin = require('html-webpack-plugin')
console.log(configuration)

// 获取入口文件
function getEntryFiles (configuration) {
  let theConfigurationType = configuration.path
  let theEntryObject = {}
  Object.keys(theConfigurationType).forEach((item) => {
    let currentRoute = theConfigurationType[item]
    theEntryObject[currentRoute.name] = currentRoute.routefile
  })
  return theEntryObject
}

// 获取模版文件配置信息
function getTemplateFiles (configuration) {
  let theConfigurationType = configuration.template
  let theTemplateObject = {
    preStyles: theConfigurationType.headfile.preStyles,
    preScripts: theConfigurationType.headfile.preScripts,
    bodyScripts: theConfigurationType.bodyfile.bodyScripts
  }
  return theTemplateObject
}

// 利用html-webpack-plugin生成静态页面
const generatePages = (packEntryFiles, options) => {
  let newHtmlWebpackPlugins = []
  Object.keys(packEntryFiles).forEach((item) => {
    newHtmlWebpackPlugins.push(new HtmlWebpackPlugin(Object.assign({
      title: '墨筝的前端技术栈学习',
      filename: `${item}.html`,
      inject: true,
      hash: true,
      chunks: [item]
    }, options)))
  })
  return newHtmlWebpackPlugins
}
module.exports = {
  packEntryFiles: getEntryFiles(configuration),
  templateFiles: getTemplateFiles(configuration),
  generatePages: generatePages
}
